package com.muyu.kafka.consumer;

import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.apache.kafka.clients.consumer.ConsumerRecords;
import org.apache.kafka.clients.consumer.KafkaConsumer;

import java.time.Duration;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Properties;

import static com.muyu.kafka.contents.KafkaContent.KAFKA_CON;
import static com.muyu.kafka.contents.KafkaContent.TOPIC;

/**
 * @author DongZl
 * @description: 消费者测试类
 * @Date 2023/8/25 18:52
 */
public class ConsumerTest {
    private static KafkaConsumer<String, String> consumer;

    private static void KfkConsumer() {
        Properties props = new Properties();
        props.put("bootstrap.servers", KAFKA_CON);
        props.put("group.id", "group01");
        props.put("enable.auto.commit", "true");
        props.put("auto.commit.interval.ms", "1000");
        props.put("key.deserializer", "org.apache.kafka.common.serialization.StringDeserializer");
        props.put("value.deserializer", "org.apache.kafka.common.serialization.StringDeserializer");
        consumer = new KafkaConsumer<>(props);
        consumer.subscribe(List.of(TOPIC));
    }

    private static void close() {
        consumer.close();
    }

    private static List<List<Object>> poll(int num) {
        List<List<Object>> result = new ArrayList<>();
        while (result.size() < num) {
            ConsumerRecords<String, String> records = consumer.poll(Duration.ofMillis(100));
            for (ConsumerRecord<String, String> record : records) {
                result.add(Arrays.asList(record.offset(), record.key(), record.value()));
                System.out.println(record.offset() +" - "+ record.key() +" - "+ record.value());
            }
        }
        return result;
    }

    public static void main (String[] args) {
        KfkConsumer();
        poll(100);
        close();
    }
}
